Subject: Re: [PATCH] powerpc/boot: Build wrapper for an appropriate CPU

From: Segher Boessenkool <[email-masked]>
Date: Thu, 7 Apr 2022 15:33:09 -0500

On Thu, Apr 07, 2022 at 03:43:20PM -0300, Murilo Opsfelder Araújo wrote:
> On 4/6/22 04:08, Joel Stanley wrote:
> >On Thu, 31 Mar 2022 at 23:46, Segher Boessenkool
> ><[email-masked]> wrote:
> >>On Thu, Mar 31, 2022 at 12:19:52PM -0300, Murilo Opsfelder Araújo wrote:
> >>>My understanding is that the default cpu type for -mcpu=powerpc64 can
> >>>change.
> >>
> >>Different subtargets (Linux, AIX, Darwin, the various BSDs, bare ELF,
> >>etc.) have different default CPUs.  It also can be set at configure time
> >>for most subtargets.
> >>
> >>Linux can be built with compilers not targetting *-linux*, so it would
> >>be best to specify a specific CPU always.
> >>
> >>>>I did a little test using my buildroot compiler which has
> >>>>with-cpu=power10. I used the presence of PCREL relocations as evidence
> >>>>that it was build for power10.
> >>>>
> >>>>$ powerpc64le-buildroot-linux-gnu-gcc -mcpu=power10 -c test.c
> >>>>$ readelf -r test.o |grep -c PCREL
> >>>>24
> >>>
> >>>It respected the -mcpu=power10 you provided.
> >>
> >>Of course.
> >>
> >>>And that's my concern.  We're relying on the compiler default cpu type.
> >>
> >>That is not the compiler default.  It is the default from who built the
> >>compiler.  It can vary wildly and unpredictably.
> >>
> >>The actual compiler default will not change so easily at all, basically
> >>only when its subtarget drops support for an older CPU.
> >>
> >>>If gcc defaults -mcpu=powerpc64le to power10, you're going to have
> >>>the same problem again.
> >>
> >>That will not happen before power10 is the minimum supported CPU.
> >>Anything else is madness.
> >
> >Murilo, does Segher's explanation address your concerns?
> 
> The comment:
> 
> "Different subtargets (Linux, AIX, Darwin, the various BSDs, bare ELF,
> etc.) have different default CPUs.  It also can be set at configure time
> for most subtargets.
> 
> Linux can be built with compilers not targetting *-linux*, so it would
> be best to specify a specific CPU always."
> 
> made me think that it's better to specify -mcpu=power8 instead of 
> -mcpu=powerpc64le
> because of such compilers not targetting *-linux*.
> 
> Did I understand Segher's comment correctly?  To be honest, I don't know
> how much concerned we should be about this scenario.

That is the long and short of it, yes.  This matters for reproducible
builds if you care for more exotic compilers (which are very common for
32 bit, but not so much for 64 bit).

> Just for the sake of consistency, if we decide to go with -mcpu=powerpc64le,
> then I think we should also change arch/powerpc/Makefile CFLAGS.
> Otherwise, we could follow what we already have in the tree and use
> -mcpu=power8 in BOOTCLAGS, too.
> 
> Practically speaking, either way works for us.  In any case:

+1

> Reviewed-by: Murilo Opsfelder Araujo <[email-masked]>
Reviewed-by: Segher Boessenkool <[email-masked]>

Segher